From 0e1cc3da8c58e7dfe6db4e97cae9aa8e6c4bc893 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 02 2021 23:09:03 +0000
Subject: [PATCH 1988/2232] Hide slice implementation details from name lookup


---

diff --git a/include/cxx.h b/include/cxx.h
index acf2b1b..41138c8 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -180,6 +180,10 @@ public:
   void swap(Slice &) noexcept;
 
 private:
+  friend void sliceInit(void *, const void *, std::size_t) noexcept;
+  friend void *slicePtr(const void *) noexcept;
+  friend std::size_t sliceLen(const void *) noexcept;
+
   std::array<std::uintptr_t, 2> repr;
 };
 
@@ -485,10 +489,6 @@ constexpr unsafe_bitcopy_t unsafe_bitcopy{};
 
 #ifndef CXXBRIDGE1_RUST_SLICE
 #define CXXBRIDGE1_RUST_SLICE
-void sliceInit(void *, const void *, std::size_t) noexcept;
-void *slicePtr(const void *) noexcept;
-std::size_t sliceLen(const void *) noexcept;
-
 template <typename T>
 Slice<T>::Slice() noexcept {
   sliceInit(this, reinterpret_cast<void *>(align_of<T>()), 0);

